/*
  look up IP addresses for fqdn in argv[1], print the first
  $ gcc -Wall -c look-up-ip.c
  $ gcc -Wall -o look-up-ip look-up-ip.o -ldjbdns
  $ ./look-up-ip localhost
*/

#include <unistd.h>
#include <dns.h>
#include <djbdns/fmt.h>

static char seed[128];

int main(int argc, char **argv) {
  stralloc arg ={0};
  stralloc ip ={0};
  stralloc out ={0};
  char buf[FMT_ULONG];

  if (! argv[1]) _exit(1);
  dns_random_init(seed);

  if (! stralloc_cats(&arg, argv[1])) _exit(1); /* copy argument */
  if (dns_ip4(&ip, &arg) == -1) _exit(1);       /* look up IP addresses */

  if (ip.len >= 4) { /* print first IP address */
    buf[fmt_ulong(buf, (unsigned long) (unsigned char) ip.s[0])] =0;
    if (! stralloc_cats(&out, buf)) _exit(1);
    if (! stralloc_append(&out, ".")) _exit(1);
    buf[fmt_ulong(buf, (unsigned long) (unsigned char) ip.s[1])] =0;
    if (! stralloc_cats(&out, buf)) _exit(1);
    if (! stralloc_append(&out, ".")) _exit(1);
    buf[fmt_ulong(buf, (unsigned long) (unsigned char) ip.s[2])] =0;
    if (! stralloc_cats(&out, buf)) _exit(1);
    if (! stralloc_append(&out, ".")) _exit(1);
    buf[fmt_ulong(buf, (unsigned long) (unsigned char) ip.s[3])] =0;
    if (! stralloc_cats(&out, buf)) _exit(1);
  }
  if (! stralloc_append(&out, "\n")) _exit(1);
  write(1, out.s, out.len);

  _exit(0);
}
