/*
  look up domain name for IP address in argv[1]
  $ gcc -Wall -c look-up-name.c
  $ gcc -Wall -o look-up-name look-up-name.o -ldjbdns
  $ ./look-up-name 127.0.0.1
*/

#include <unistd.h>
#include <dns.h>

static char seed[128];

int main(int argc, char **argv) {
  stralloc arg ={0};
  stralloc ip ={0};
  stralloc out ={0};

  if (! argv[1]) _exit(1);
  dns_random_init(seed);

  if (! stralloc_cats(&arg, argv[1])) _exit(1); /* copy argument */
  if (dns_ip4(&ip, &arg) == -1) _exit(1);       /* pack 4-byte IP address */
  if (dns_name4(&out, ip.s) == -1) _exit(1);    /* look up name */

  if(! stralloc_append(&out, "\n")) _exit(1);
  write(1, out.s, out.len);

  _exit(0);
}
